#!/bin/sh
#This script needs wget and cvs
#UpdateOpenTracker 1.2 by misza ( misza@ihug.com.au )
config_bin=/boot/home/config/bin
DATE=`date +%d_%m_%y_%k-%M-%S`

scream_restart()
{
alert --stop "BeOS is going to be rebooted. Please save all your work before clicking REBOOT to reboot. See you on the other side" "REBOOT"
_retval=$?
[ $_retval -eq 0 ] && shutdown -r

}
#----get the tools needed for compilation
dload_tools()
{
if [ -f $config_bin/wget ]; then 
		if [ `uname -m` == "BePC" ]; then
		wget http://opentracker.sourceforge.net/downloads/x86/tools-x86.tgz
		echo "Extracting tools"
		tar xzf tools-x86.tgz
		rm -f tools-x86.tgz
		else
		wget http://opentracker.sourceforge.net/downloads/ppc/tools-ppc.tgz
		echo "Extracting tools"
		tar xzf tools-ppc.tgz
		rm -f tools-ppc.tgz
		fi
else
	echo	
	echo -e "wget is not installed you can get it from \e[0;34mhttp://www.bebits.com/app/2848\e[m"
	echo -e "Download it and place the wget binary in \e[0;31m$config_bin\e[m"
	echo "Then run this script again."
	exit 0
	fi
}
#check if tools need to be dloaded
checktools()
{
if [ -d "bin" ]; then
	echo "tools are installed. ok."
	else
	dload_tools
fi
}
#compile & install OpenTracker
compile()
{
	cd opentracker
	make clean
	make
	make install
}

restart_ot_deskbar()
{
	/system/Deskbar &
	/system/Tracker &
	alert "OpenTracker is now updated. Enjoy. 8^)" &
}

#-------last step, workaround for bug in OpenTracker Restarting
warning()
{
quit application/x-vnd.Be-TRAK 
quit application/x-vnd.Be-TSKB
alert --stop "If you were NOT running OpenTracker BEFORE running this script you MUST reboot to avoid a bug in OpenTracker. Otherwise you may proceed." "REBOOT" "PROCEED"
_retval=$?
[ $_retval -eq 0 ] && scream_restart
[ $_retval -eq 1 ] && restart_ot_deskbar
exit 0
}
#----check if OpenTracker dir exists, remove old files
check_ot_dir()
{
cd ~
if [ -d "OpenTracker" ]; then
	cd OpenTracker
	rm -rf opentracker
	rm -f OpenTracker-src.tgz
	rm -f OpenTracker-x86.zip
	rm -f OpenTracker-ppc.zip
else
	mkdir OpenTracker
	cd OpenTracker
	
fi

}
#------backup old Tracker/Deskbar/libtracker.so
backup_old()
{
cd /system
tar czf "OpenTrackerBackup_$DATE.tar.gz" Tracker Deskbar lib/libtracker.so
echo -e "Created backup archive at:\n/system/OpenTrackerBackup_$DATE.tar.gz"
}

#--------------------------CVS--------------------
build_cvs()
{
check_ot_dir
checktools
backup_old
cd ~/OpenTracker

if [ -f $config_bin/cvs ]; then
	echo
	echo -e "\e[0;31mYou just need to press ENTER here where it asks you for a password.\e[m"
	cvs -d:pserver:anonymous@cvs.opentracker.sourceforge.net:/cvsroot/opentracker login
	cvs -z3 -d:pserver:anonymous@cvs.opentracker.sourceforge.net:/cvsroot/opentracker co opentracker

else
	echo
	echo "Downloading cvs....Please Wait"
	wget http://homepages.ihug.com.au/~brentmor/cvs.zip
	echo "Installing cvs"
	unzip -d -q /boot/home/config/bin/ cvs.zip
	rm -f cvs.zip
	echo -e "\e[0;31mYou just need to press ENTER here where it asks you for a password.\e[m"
	cvs -d:pserver:anonymous@cvs.opentracker.sourceforge.net:/cvsroot/opentracker login
	cvs -z3 -d:pserver:anonymous@cvs.opentracker.sourceforge.net:/cvsroot/opentracker co opentracker
fi

compile
warning
exit 0
}
#--------------------------SOURCE--------------------
nightly_source()
{
	check_ot_dir
	checktools
	backup_old
	cd ~/OpenTracker

#start getting of source
	wget http://opentracker.sourceforge.net/downloads/OpenTracker-src.tgz
	echo "Expanding source"
	tar xzf OpenTracker-src.tgz
	rm -f OpenTracker-src.tgz
	compile
	warning
exit 0
}

#--------------------------STABLE--------------------
stable()
{
check_ot_dir
backup_old
cd ~/OpenTracker

if [ `uname -m` == "BePC" ]; then
		wget http://opentracker.sourceforge.net/downloads/x86/OpenTracker-x86.zip
		unzip -o -d /system OpenTracker-x86.zip
		rm -f OpenTracker-x86.zip
		else
		http://opentracker.sourceforge.net/downloads/ppc/OpenTracker-ppc.zip
		unzip -o -d /system OpenTracker-ppc.zip
		rm -f OpenTracker-ppc.zip
		fi
warning
exit 0
}

#---Start it all off
alert --idea "What do you want to do? Compile OpenTracker from CVS (bleeding edge) OR Compile OpenTracker from SOURCE (nightly built sources tarball) OR Install the latest STABLE binary OpenTracker release" "CVS" "SOURCE" "STABLE"

_retval=$?
[ $_retval -eq 0 ] && build_cvs
[ $_retval -eq 1 ] && nightly_source
[ $_retval -eq 2 ] && stable
